package compbio.data.sequence;

import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;

import compbio.util.annotation.Immutable;

/*
 * RNA secondary structure
 */

@XmlAccessorType(XmlAccessType.FIELD)
public final class RNAstruct {
	
	private String sequence;
	private String structure; // needs to be array to deal with all output
	private Float minEnergy;
	private Float energySum1; private Float energySum2;
	
	
	public RNAstruct() {
		// default JaxB Constructor
	}
	
	public RNAstruct(String sequence, String structure, Float minEnergy
			, Float energySum1, Float energySum2) {
		this.sequence = sequence;
		this.structure = structure;
		this.minEnergy = minEnergy;
		this.energySum1 = energySum1;
		this.energySum2 = energySum2;
	}
	
	public String getSequence() {
		return sequence;
	}
	
	public String getStructure() {
		return structure;
	}
	
	public Float getEnergy() {
		return minEnergy;
	}
	
	
	@Override
	public String toString() {
		String newLine = System.getProperty("line.separator",".");
		return sequence + newLine + structure + " (" + minEnergy.toString() 
				+ " = " + energySum1.toString() + " +  " + energySum2.toString()
				+ ")"; 
	}
	
	@Override 
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof RNAstruct)) {
			return false;
		}
		RNAstruct st = (RNAstruct) obj;
		if (!(this.getSequence() == st.getSequence() &&
				this.getStructure() == st.getStructure() &&
				this.getEnergy() == st.getEnergy())) {
			return false;
		}
		
		return true;
	}
}


